;*********************************************************************
; PdcTest.asm
;
; This file was generated from PdcTest.fw
; See PdcTest.fw for comments and documentation
;
;*********************************************************************

DATA SECTION
MainWnd DD 0
SubWnd DD 0
Title DB 'A pdcurses 2.6 test with GoAsm',0
IDI_ICON = 100d
C_LIGHT_CYAN = 1
C_LIGHT_RED = 2
C_WHITE = 3
; from curses.h
COLOR_WHITE = 7
COLOR_BLACK = 0
COLOR_RED = 4
COLOR_CYAN = 3
A_BOLD = 0x00800000

CODE SECTION
START:
call AppInit
call DisplayInit
call TestPdc
call AppExit
ret

AppInit:
push 0
call GetModuleHandleA
push IDI_ICON
push eax
call LoadIconA
push addr Title
call SetConsoleTitleA
ret

DisplayInit:
call initscr
mov [MainWnd],eax

push 0;
call curs_set
add esp,4h

call start_color

push COLOR_BLACK
push COLOR_WHITE
push C_WHITE
call init_pair
add esp,0Ch

push COLOR_BLACK
push COLOR_RED
push C_LIGHT_RED
call init_pair
add esp,0Ch

push COLOR_BLACK
push COLOR_CYAN
push C_LIGHT_CYAN
call init_pair
add esp,0Ch

ret

TestPdc:

; simplify the color change with a macro
mov eax, C_LIGHT_RED
shl eax,24d
add eax,A_BOLD
invoke  wattrset,[MainWnd],eax
add esp,8h
invoke  mvprintw,2,30,"*** FORGE OF STEEL ***"
add esp,0Ch

mov eax, C_LIGHT_CYAN
shl eax,24d
add eax,A_BOLD
invoke  wattrset,[MainWnd],eax
add esp,8h
invoke  mvprintw,4,19,"Version 0.01-Alpha-Win (7/14/2005 11:55 AM)"
add esp,0Ch
invoke  mvprintw,6,30,"(C)2005 Brian Algeri"
add esp,0Ch

mov eax, C_WHITE
shl eax,24d
add eax,A_BOLD
invoke  wattrset,[MainWnd],eax
add esp,8h
invoke  mvprintw,22,23,"A ascii roguelike sample title screen"
add esp,0Ch
invoke  mvprintw,24,31,"[Space To Continue]"
add esp,0Ch

call refresh

invoke newwin,14,60,8,10
add esp,10h
mov [SubWnd],eax

invoke box,[SubWnd],0,0
add esp,0Ch

invoke mvwprintw,[SubWnd],1,1,'Test of a sub window with a border'
add esp,10h
invoke mvwprintw,[SubWnd],3,1, \
       'Not sure what codepage pdcurses uses for the border - 437'
add esp,10h
invoke mvwprintw,[SubWnd],4,1, \
       'My console defaults to CP 437, CP 850 should also work'
add esp,10h
invoke mvwprintw,[SubWnd],5,1, \
       'as most of the line characters are the same as 437. Lucida'
add esp,10h
invoke mvwprintw,[SubWnd],6,1, \
       'Console font with codepage of 1252 does not work,different'
add esp,10h
invoke mvwprintw,[SubWnd],7,1, \
       'line characters. Can always change the pdcurses src to use'
add esp,10h
invoke mvwprintw,[SubWnd],8,1, \
       "different CP's extended chars. This would have different"
add esp,10h
invoke mvwprintw,[SubWnd],9,1, \
       "version's of curses.dll if ever a issue and required."
add esp,10h


invoke wrefresh,[SubWnd]
add esp,4h

L1:
push [MainWnd]
call wgetch
add esp,4h
cmp eax,20h  ;check for space char
jnz <L1

invoke delwin,[SubWnd]
add esp,4h
call endwin

ret

AppExit:
push 0
call ExitProcess
ret


