; ********************************************************************
;DxTest.asm
;
;Desc: Simple Window with COM object test
;      DirectX Init amd Release
;
;Author: Brian Algeri <bdasp@hotmail.com>
;Rev: Init 7/18/2005
;
;Type: GoAsm File
; ********************************************************************

.Data
hInst dd 0
hWnd dd 0
WNDCLASS dd 10d dup 0
MSG dd 7d dup 0
WndClassName db 'WC',0

lpDD dd 0
lpDDSPrimary dd 0
ddsd dd 6Ch dup 0 ;DDSURFACEDESC
ddscaps dd 0      ;DDSCAPS

DD_OK = 0
DDSCL_FULLSCREEN = 1h
DDSCL_EXCLUSIVE	= 10h
ddbpp = 32
ddheight = 480
ddwidth = 640
DDSD_CAPS = 1h
DDSD_PITCH = 8h
DDSCAPS_PRIMARYSURFACE = 200h
DDLOCK_WAIT = 1h
DDERR_SURFACELOST = 0887601C2h
DDWAITVB_BLOCKBEGIN = 1h

COLOR_WINDOW=6d
BLACK_BRUSH=4d
WS_POPUP=80000000h
CAPTION=0C00000h
SIZEBOX=40000h
SYSMENU=80000h
MINIMIZEBOX=20000h
MAXIMIZEBOX=10000h
CS_VREDRAW=1
CS_HREDRAW=2
CS_CLASSDC=40h

WM_CREATE = 1h
WM_DESTROY = 2h
WM_KEYDOWN = 100h
WM_QUIT = 12h
VK_ESCAPE =1Bh
SW_SHOWNORMAL = 1
IDC_ARROW=7F00h
PM_REMOVE = 1

; ********************************************************************

.Code
START:
call InitApp
call RegWndClass 
call CreateWnd
call DxInit
call MsgLoop
call DxExit
call ExitApp 
ret

; --------------------------------------------------------------------

InitApp:
push 0
call GetModuleHandleA
mov [hInst],eax
ret

; --------------------------------------------------------------------

RegWndClass:
mov ebx, addr WNDCLASS
push IDC_ARROW,0
call LoadCursorA
mov D[ebx+18h],eax
mov eax,[hInst]
mov D[ebx+10h],eax
push BLACK_BRUSH
call GetStockObject
mov D[ebx+1Ch],eax
mov D[ebx+4h],addr WndProc
mov D[ebx+24h],addr WndClassName
mov D[ebx],CS_VREDRAW+CS_HREDRAW+CS_CLASSDC

push ebx
call RegisterClassA
ret

; --------------------------------------------------------------------

CreateWnd:
push 0,[hInst],0,0
push 480d,640d,0,0
push WS_POPUP
push 'DxTest',Addr WndClassName
push 0
call CreateWindowExA
mov [hWnd],eax

push eax
call SetFocus
push 0
call ShowCursor

ret

; --------------------------------------------------------------------

DxInit:
push 0
push addr lpDD,0
call DirectDrawCreate

push DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN
push [hWnd]
mov eax, [lpDD]
push eax
mov eax,[eax]
call [eax + 50h] ;IDirectDrawVtbl SetCooperativeLevel

push ddbpp,ddheight,ddwidth
mov eax, [lpDD]
push eax
mov eax,[eax]
call [eax + 54h] ;IDirectDrawVtbl SetDisplayMode

mov D[ddsd],sizeof ddsd
mov D[ddsd+4],DDSD_CAPS
mov D[ddsd+68h],DDSCAPS_PRIMARYSURFACE
push 0
push addr lpDDSPrimary, addr ddsd
mov eax,[lpDD]
push eax
mov eax,[eax]
call [eax + 18h] ;IDirectDrawVtbl CreateSurface

push SW_SHOWNORMAL
push [hWnd]
call ShowWindow 

ret

; --------------------------------------------------------------------

MsgLoop:
push 0,0,0
push addr MSG
call GetMessageA
or eax,eax
jz >L1
push addr MSG
call TranslateMessage
push addr MSG
call DispatchMessageA
jmp MsgLoop
L1:
ret

; this needs some work and redesign
;MsgLoop:
;push [PM_REMOVE],0,0,0
;push addr MSG
;call PeekMessageA
;or eax,eax
;jz >L1
;cmp D[MSG+8h],WM_QUIT
;jne >:
;push [MSG+0Ch]
;call PostQuitMessage
;ret
;:
;push addr MSG
;call TranslateMessage
;push addr MSG
;call DispatchMessageA
;jmp MsgLoop
;L1:
;call GetFocus
;cmp eax,[hWnd]
;jne >L8
;mov D[ddsd],sizeof ddsd  ;dwSize
;mov D[ddsd+4],DDSD_PITCH ;dwFlags  
;L2:
;push 0,DDLOCK_WAIT,addr ddsd,0
;mov eax, [lpDDSPrimary]
;push eax
;mov eax,[eax]
;call [eax + 64h] ;IDirectDrawSurfaceVtbl mLock
;cmp eax,DD_OK
;je >L7
;CMP eax,DDERR_SURFACELOST
;JNE >:
;mov eax, [lpDDSPrimary]
;push eax
;mov eax,[eax]
;call [eax + 6Ch] ;IDirectDrawSurfaceVtbl Restore
:
;jmp <L2
;L7:

;push 0,DDWAITVB_BLOCKBEGIN 
;mov eax, [lpDD]
;push eax
;mov eax,[eax]
;call [eax + 58h] ;IDirectDrawVtbl WaitForVerticalBlank

; plot here

;push [ddsd+24h]
;mov eax, [lpDDSPrimary]
;push eax
;mov eax,[eax]
;call [eax + 80h] ;IDirectDrawSurfaceVtbl Unlock

;L8:
;jmp < MsgLoop

; --------------------------------------------------------------------

DxExit:
mov eax, [lpDD]
push eax
mov eax,[eax]
call [eax + 4Ch] ;IDirectDrawVtbl RestoreDisplayMode

;mov eax, [lpDDSPrimary]
;push eax
;mov eax,[eax]
;call [eax + 8h] ;IDirectDrawSurfaceVtbl Release
;mov D[lpDDSPrimary],0

mov eax, [lpDD]
push eax
mov eax,[eax]
call [eax + 8h] ;IDirectDrawVtbl Release
mov D[lpDD],0
ret

; --------------------------------------------------------------------

ExitApp:
push [hInst],addr WndClassName
call UnregisterClassA
push [MSG+8h]
call ExitProcess
ret

; --------------------------------------------------------------------

WndProc:
push ebp
mov ebp,esp

cmp D[ebp+0Ch],WM_CREATE
jne >:
xor eax,eax
jmp >L2
:

cmp D[ebp+0Ch],WM_KEYDOWN
jne >:
cmp D[ebp+10h],VK_ESCAPE
jne >:
push 0
call PostQuitMessage
jmp >L2
:

cmp D[ebp+0Ch],WM_DESTROY
jne >L1
push 0
call PostQuitMessage
jmp >L2

L1:
push [ebp+14h],[ebp+10h]
push [ebp+0Ch],[ebp+8h]
call DefWindowProcA
pop ebp
ret 10h

L2:
xor eax,eax
pop ebp
ret 10h

; ********************************************************************
