; ********************************************************************
;Test.asm
;Desc: A fun little project to test GoAsm with the HX DOS Extender
;      Uses int 21h, int 10h, int 16h services. Prints some messeges
;      in Text mode and Vesa 640x480 8bit graphics mode.
;
;Author: Brian Algeri <bdasp@hotmail.com>
;Rev: Init 7/19/2005
;
;Build: see Readme.txt
;Type: GoAsm file
; ********************************************************************

.data
; 01 - ascii face 
; 13 - CR
; 10 - LF
; $ - DOS string terminator

msg1    db 13,10,'Hello, world! ',01,'(press a key)',01,13,10,'$'
msg2    db 'Press a key for vesa mode 101h test - 640x480 8bit',13,10,'$'
msg3    db 'Running in vesa mode 101h ',01,'(press a key)',01,13,10,'$'
msg4    db 'Back in console mode - 80x25 Text ',01,'(press key to exit)',01,13,10,'$'

; --------------------------------------------------------------------

.code
_main:
call ConsoleMode  ;clear screen
call IntroMsgs
call VesaModeTest
call ConsoleMode
call ExitMsg
call Exit
ret

; --------------------------------------------------------------------

Exit:
mov ax, 4C00h
int 21h
ret

; --------------------------------------------------------------------

IntroMsgs:
push offset msg1
call MsgKeyPress
push offset msg2
call MsgKeyPress
ret

; --------------------------------------------------------------------

ConsoleMode:
mov ah,0
mov al,3h
int 10h
ret

; --------------------------------------------------------------------

VesaModeTest:
mov ah,4Fh
mov al,2
mov bx,101h ;the vesa mode
int 10h
push offset msg3
call MsgKeyPress
ret

; --------------------------------------------------------------------

ExitMsg:
push offset msg4
call MsgKeyPress
ret

; --------------------------------------------------------------------

MsgKeyPress:
push ebp
mov ebp,esp
mov ah, 09h
mov edx,[ebp+8] ;[ebp+8h] is the msg parameter
int 21h
mov ah,0
int 16h
pop ebp
ret 4

; ********************************************************************
